;Pilote (bibliothque dynamique) pour Arduino + capteur de poids DFRobot SEN0160
;  utiliser avec un programme arduino qui renvoie le poids lorsqu'on a envoy 
; un caractre : A pour connexion en 0-1, B pour connexion en 2-3, C pour connexion en 4-5
; Copyright (C) 2013 Pierre Dieumegard (pierre.dieumegard@free.fr)
;   http://sciencexp.free.fr
; (exemples de programmes d'application de la famille Mensurasoft)
;
;Ce logiciel est un logiciel libre au sens LGPL3 (http://www.gnu.org/licenses/lgpl.txt)


;Tous droits rservs.

;Cette bibliothque est un logiciel libre ; vous pouvez la redistribuer ou
;la modifier suivant les termes de la Licence Gnrale Publique Limite
;GNU telle que publie par la Free Software Foundation ; soit la
;version 3 de la License, soit ( votre gr) toute version ultrieure.
;Cette bibliothque est distribue dans lespoir quelle sera utile, mais
;SANS AUCUNE GARANTIE : sans mme la garantie implicite de
;COMMERCIALISABILIT ou dADQUATION  UN OBJECTIF PARTICULIER. Consultez
;la Licence Gnrale Publique Limite pour plus de dtails.
;Vous devriez avoir reu une copie de la Licence Gnrale Publique Limite
;GNU avec cette bibliothque ; si ce nest pas le cas, crivez  la :
;Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
;MA 02110-1301, USA.

;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU Lesser General Public
; License As published by the Free Software Foundation; either
; version 2.1 of the License, Or (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE. See the GNU
; Lesser General Public License For more details.
; 
; You should have received a copy of the GNU Lesser General Public
; License along With this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA



;  programme  implanter dans Arduino
; /* sample For digital weight scale of hx711
;  * library design: Weihong Guan (@aguegu)
;  * library host on
;  *https://github.com/aguegu/ardulibs/tree/3cdb78f3727d9682f7fd22156604fc1e4edd75d1/hx711
;  */
; 
; // Hx711.DOUT - pin #A2
; // Hx711.SCK - pin #A3
; 
; #include <Hx711.h>
; Hx711 scale01(A0, A1);
; Hx711 scale23(A2, A3);
; Hx711 scale45(A4, A5);
; int car_recu = 0;
; void setup() {
;   Serial.begin(9600);
; }
; 
; void loop() {
;    If (Serial.available() > 0) {
;          car_recu = Serial.Read();
;          If (car_recu==65){Serial.print(scale01.getGram(), 1);}
;          If (car_recu==66){Serial.print(scale23.getGram(), 1);}
;          If (car_recu==67){Serial.print(scale45.getGram(), 1);}
;           
;          Serial.println(" g");
;          Delay(100);
;          While (Serial.available() > 0) {
;          car_recu = Serial.Read();
;                                          }
;                                 }
; }















Global nea$
Global nead$
Global nsa$
Global nsad$
Global neb$
Global nsb$

Global memosa .w
Global memosad .d
Global Dim memosb .w (8)

Global titre$ 

Global detail$
Global wretour .w
Global dretour .d
Global delai .w
Global t1 .d
Global t2 .d
Global memom0 .s="0"
Global memom1 .s="0"
Global memom2 .s="0"


Procedure .s portdisponible() 
  chloc$=""
         Select #PB_Compiler_OS 
        Case #PB_OS_Windows
          baseport$="Com"
          numdepart=1
          For i=numdepart To 20    
            resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i), 38400, #PB_SerialPort_EvenParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
            If resultat >0
          chloc$=chloc$+"|"+baseport$+StrU(i)
          CloseSerialPort(resultat)
          Print("******Trouv !**********")
        EndIf
        ;PrintN(baseport$+StrU(i))
           Next
         Case #PB_OS_Linux
             baseport$="/dev/ttyS"
             numdepart=0
             For i=numdepart To 20    
                resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i),38400,#PB_SerialPort_EvenParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
                    If resultat >0
               chloc$=chloc$+"|"+baseport$+StrU(i)
              CloseSerialPort(resultat)
                    EndIf
                  Next
             baseport$="/dev/ttyUSB"
             numdepart=0
             For i=numdepart To 20    
                resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i),38400,#PB_SerialPort_EvenParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
                    If resultat >0
               chloc$=chloc$+"|"+baseport$+StrU(i)
              CloseSerialPort(resultat)
                    EndIf
                  Next
                   baseport$="/dev/ttyACM"
             numdepart=0
             For i=numdepart To 20    
                resultat= OpenSerialPort( #PB_Any, baseport$+StrU(i),38400, #PB_SerialPort_EvenParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
                    If resultat >0
               chloc$=chloc$+"|"+baseport$+StrU(i)
              CloseSerialPort(resultat)
                    EndIf
              Next
          EndSelect
 
 
 ProcedureReturn(chloc$)
EndProcedure  

Procedure .s questionne_balance(ch$)
  buffer.b=0
  memoval$="-777.77"
text$=""
WriteSerialPortString(0,ch$)
Delay(delai)
ReadSerialPortData(0,@buffer,1)
text$=Chr(buffer)

While AvailableSerialPortInput(0)>0
  If ReadSerialPortData(0,@buffer,1)
      text$=text$+Chr(buffer)      
      EndIf
    Wend
    ch$=text$
ch2$=""
  For j=1 To Len(ch$)
    If (Mid(ch$,j,1) >Chr(44)) And(Mid(ch$,j,1)<Chr(58))
      ch2$=ch2$+Mid(ch$,j,1)
    EndIf 
  Next j
  If Len(ch2$)<2
    ;ch2$="-777.77"
    ch2$=memoval$
  Else
    memoval$=ch2$
  EndIf
  
ProcedureReturn(ch2$+Chr(13))
EndProcedure
 


ProcedureDLL .d ead(n .w)
  
  If (n=0) 
    chloc$=memom0
    If (ElapsedMilliseconds()-t1>1000)
  chloc$=questionne_balance("A")
  t1=ElapsedMilliseconds()
  memom0=chloc$
    EndIf 
  ElseIf (n=1) 
    chloc$=memom1
    If (ElapsedMilliseconds()-t1>1000)
  chloc$=questionne_balance("B")
  t1=ElapsedMilliseconds()
  memom1=chloc$
  EndIf 
ElseIf(n=2) 
  chloc$=memom2
  If (ElapsedMilliseconds()-t1>1000)
  chloc$=questionne_balance("C")
  t1=ElapsedMilliseconds()
  memom2=chloc$
  EndIf 
  Else
  chloc$="-777.77"
EndIf
ProcedureReturn(ValD(chloc$))
EndProcedure



ProcedureDLL .s nead(n .w)
Select n
  Case 0
    nead$="masse (g) contacts 0-1"
  Case 1
    nead$="masse (g) contacts 2-3"
  Case 2 
    nead$="masse (g) contacts 4-5"
   Default 
    nead$=""
    EndSelect
ProcedureReturn(nead$)
EndProcedure

ProcedureDLL .w ea(n .w)

valretour=Round(ead(n)*10, #PB_Round_Nearest)
   
ProcedureReturn(valretour)
EndProcedure

ProcedureDLL .s nea (n .w)
  Select n
  Case 0
    nea$="masse (dg) contacts 0-1"
  Case 1
    nea$="masse (dg) contacts 2-3"
  Case 2 
    nea$="masse (dg) contacts 4-5"
  Default 
    nea$=""
  EndSelect
ProcedureReturn(nea$)
EndProcedure

ProcedureDLL .w sa(n .w , valeur .w)
ProcedureReturn(-777)
  
memosa=valeur
ProcedureReturn (valeur)
EndProcedure



ProcedureDLL .s nsa (n .w)

  nsa$=""
  ProcedureReturn(nsa$)
EndProcedure

ProcedureDLL .w rsa(n .w)
ProcedureReturn(memosa)
EndProcedure


ProcedureDLL .d sad (n .w , valeur .d)
  If n=0
    delai=Round(valeur, #PB_Round_Nearest)    
    memosad=valeur
    EndIf
ProcedureReturn(valeur)
EndProcedure

ProcedureDLL .s nsad (n .w)
  nsad$=""
  If n=0 : nsad$="dlai/mesure (s)":EndIf 
   ProcedureReturn(nsad$)
EndProcedure

ProcedureDLL .d rsad(n .w)
ProcedureReturn(memosad)
EndProcedure

ProcedureDLL .w eb (n .w)
ProcedureReturn(-777)
EndProcedure

ProcedureDLL .s neb (n .w)
    neb$=""
   ProcedureReturn neb$
EndProcedure

ProcedureDLL .w sb(n .w , valeur .w)
   memosb(n)=valeur
   ProcedureReturn(-777)
EndProcedure

ProcedureDLL .s nsb(n .w)
   nsb$=""
 ProcedureReturn(nsb$)
EndProcedure

ProcedureDLL .w rsb(n .w)
ProcedureReturn(memosb(n))
EndProcedure



ProcedureDLL .s titre()
titre$="Arduino+SEN0160"
ProcedureReturn(titre$)
EndProcedure 


ProcedureDLL.s detail()
detail$="balance Arduino+DFRobot SEN0160(9600 bauds) par P. Dieumegard, le 6 avril 2015"
ProcedureReturn(detail$)
EndProcedure

ProcedureDLL .w stdea(n .w)
ProcedureReturn(ea(n))
EndProcedure

ProcedureDLL .s stdnea(n .w)
ProcedureReturn (nea(n))
EndProcedure



ProcedureDLL .d stdead(n .w)
;ProcedureReturn(n*1.1)
ProcedureReturn(ead(n))
EndProcedure

ProcedureDLL .s stdnead(n .w)
ProcedureReturn(nead(n))
 EndProcedure
 
 
ProcedureDLL .w stdsa(n .w , valeur .w)
ProcedureReturn(sa(n,valeur))
EndProcedure

ProcedureDLL .s stdnsa(n .w)
ProcedureReturn(nsa(n))
EndProcedure

ProcedureDLL .w stdrsa(n .w)
ProcedureReturn (rsa(n))
EndProcedure

ProcedureDLL .d stdsad(n .w , valeur .d)
ProcedureReturn(sad(n,valeur))
EndProcedure
 
 ProcedureDLL .s stdnsad(n .w)
 ProcedureReturn(nsad(n))
 EndProcedure
 
 ProcedureDLL .d stdrsad(n .w)
ProcedureReturn(rsad(n))
EndProcedure

ProcedureDLL .w stdeb(n .w)
ProcedureReturn(eb(n))
EndProcedure

ProcedureDLL .s stdneb(n .w)
ProcedureReturn (neb(n))
EndProcedure

ProcedureDLL .w stdsb(n .w , etat .w)
ProcedureReturn(sb(n,etat))
EndProcedure

ProcedureDLL .s stdnsb(n .w)
ProcedureReturn(nsb(n))
EndProcedure

ProcedureDLL .w stdrsb(n .w)
ProcedureReturn(rsb(n))
EndProcedure

 
 
 
 
 ProcedureDLL .s stdtitre()
   titre$=titre()
   ProcedureReturn(titre$)
 EndProcedure
 
 ProcedureDLL .s stddetail()
 detail$=detail()
 ProcedureReturn (detail$)
 EndProcedure
 
 ProcedureDLL .d eadouble(x .d)
 ProcedureReturn(ead(Round(x, #PB_Round_Nearest)))
 EndProcedure
 
 ProcedureDLL .s neadouble(x .d)
 ProcedureReturn(nead(Round(x, #PB_Round_Nearest)))
 EndProcedure
 
 
 
 ProcedureDLL .d sadouble(n .d , valeur .d)
 ProcedureReturn(sad(Round(n, #PB_Round_Nearest),valeur))
 EndProcedure
 
 ProcedureDLL .s nsadouble(n .d)
 ProcedureReturn nsad(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d rsadouble(n .d)
 ProcedureReturn rsad(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d ebdouble(n .d)
 ProcedureReturn eb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .s nebdouble(n .d)
 ProcedureReturn neb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d sbdouble(n .d , valeur .d)
 ProcedureReturn sb(Round(n, #PB_Round_Nearest),Round(valeur, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .s nsbdouble(n .d)
 ProcedureReturn nsb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d rsbdouble(n .d)
 ProcedureReturn rsb(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .d stdeadouble(n .d)
 ProcedureReturn ead(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureDLL .s stdneadouble(n .d)
 ProcedureReturn neadouble(n)
 EndProcedure
 
 ProcedureDLL .d stdsadouble(n .d , valeur .d)
 ProcedureReturn sadouble(n,valeur)
 EndProcedure
 
 ProcedureDLL .s stdnsadouble(n .d)
 ProcedureReturn nsadouble(n)
 EndProcedure
 
 ProcedureDLL .d stdrsadouble(n .d)
 ProcedureReturn rsadouble(n)
 EndProcedure
 
  ProcedureDLL .d stdebdouble(n .d)
  ProcedureReturn ebdouble(n)
  EndProcedure
  
  ProcedureDLL .s stdnebdouble(n .d)
  ProcedureReturn nebdouble(n)
  EndProcedure
  
  ProcedureDLL .d stdsbdouble(n .d, valeur .d)
  ProcedureReturn sbdouble(n,valeur)
  EndProcedure
  
  ProcedureDLL .s stdnsbdouble(n .d)
  ProcedureReturn nsbdouble(n)
  EndProcedure
  
  ProcedureDLL .d stdrsbdouble(n .d)
  ProcedureReturn rsbdouble(n)
  EndProcedure
  
  ProcedureDLL .s stdeadstr(n .s)
    ProcedureReturn StrF(stdead(ValF(n)))
  EndProcedure 
  
  ProcedureDLL .s stdneadstr(n .s)
    ProcedureReturn stdnead(ValF(n))
  EndProcedure 
  
  ProcedureDLL .s stdsadstr(n .s, valeur .s)
    ProcedureReturn StrF(stdsad(ValF(n),ValF(valeur)))
  EndProcedure
  
  ProcedureDLL .s stdnsadstr(n .s)
    ProcedureReturn stdnsad(ValF(n))
    EndProcedure
  
  ProcedureDLL .s stdebstr(n .s)
    ProcedureReturn StrF(stdeb(Val (n)))
  EndProcedure
  
  ProcedureDLL .s stdnebstr(n .s)
    ProcedureReturn neb(Val(n))
  EndProcedure
  
  ProcedureDLL .s stdsbstr(n .s , valeur .s)
    ProcedureReturn Str(sb(Val(n),Val(valeur)))
  EndProcedure
  
  ProcedureDLL .s stdnsbstr(n .s)
    ProcedureReturn nsb(Val(n))
  EndProcedure
  
  ; fonctions cdecl surtout pour Linux

ProcedureCDLL .i cea(n .i)
ProcedureReturn(ea(n))
EndProcedure

ProcedureCDLL .s cnea(n .i)
ProcedureReturn (nea(n))
EndProcedure



ProcedureCDLL .d cead(n .i)
;ProcedureReturn(n*1.1)
ProcedureReturn(ead(n))
EndProcedure

ProcedureCDLL .s cnead(n .i)
;If n=0 
 ; ProcedureReturn ("entre an. 0")
  ;Else
  ;ProcedureReturn("")
;  EndIf  
ProcedureReturn(nead(n))
 EndProcedure
 
 
ProcedureCDLL .i csa(n .i , valeur .i)
ProcedureReturn(sa(n,valeur))
EndProcedure

ProcedureCDLL .s cnsa(n .i)
ProcedureReturn(nsa(n))
EndProcedure

ProcedureCDLL .i crsa(n .i)
ProcedureReturn (rsa(n))
EndProcedure

ProcedureCDLL .d csad(n .i , valeur .d)
ProcedureReturn(sad(n,valeur))
EndProcedure
 
 ProcedureCDLL .s cnsad(n .i)
 ProcedureReturn(nsad(n))
 EndProcedure
 
 ProcedureCDLL .d crsad(n .i)
ProcedureReturn(rsad(n))
EndProcedure

ProcedureCDLL .i ceb(n .i)
ProcedureReturn(eb(n))
EndProcedure

ProcedureCDLL .s cneb(n .i)
ProcedureReturn (neb(n))
EndProcedure

ProcedureCDLL .i csb(n .i , etat .i)
ProcedureReturn(sb(n,etat))
EndProcedure

ProcedureCDLL .s cnsb(n .i)
ProcedureReturn(nsb(n))
EndProcedure

ProcedureCDLL .i crsb(n .i)
ProcedureReturn(rsb(n))
EndProcedure

 
 
 
 
 ProcedureCDLL .s ctitre()
 titre$="titre dll"
 ProcedureReturn(titre$)
 EndProcedure
 
 ProcedureCDLL .s cdetail()
 detail$="dtail de la dll fictive"
 ProcedureReturn (detail$)
 EndProcedure
 
;  ProcedureCDLL .s ccalibration(ch .s)
;    ProcedureReturn(calibration(ch))
;  EndProcedure
;  
 
 ProcedureCDLL .d ceadouble(n .d)
 ProcedureReturn ead(Round(n, #PB_Round_Nearest))
 EndProcedure
 
 ProcedureCDLL .s cneadouble(n .d)
 ProcedureReturn neadouble(n)
 EndProcedure
 
 ProcedureCDLL .d csadouble(n .d , valeur .d)
 ProcedureReturn sadouble(n,valeur)
 EndProcedure
 
 ProcedureCDLL .s cnsadouble(n .d)
 ProcedureReturn nsadouble(n)
 EndProcedure
 
 ProcedureCDLL .d crsadouble(n .d)
 ProcedureReturn rsadouble(n)
 EndProcedure
 
  ProcedureCDLL .d cebdouble(n .d)
  ProcedureReturn ebdouble(n)
  EndProcedure
  
  ProcedureCDLL .s cnebdouble(n .d)
  ProcedureReturn nebdouble(n)
  EndProcedure
  
  ProcedureCDLL .d csbdouble(n .d, valeur .d)
  ProcedureReturn sbdouble(n,valeur)
  EndProcedure
  
  ProcedureCDLL .s cnsbdouble(n .d)
  ProcedureReturn nsbdouble(n)
  EndProcedure
  
  ProcedureCDLL .d crsbdouble(n .d)
  ProcedureReturn rsbdouble(n)
  EndProcedure
  
   ProcedureCDLL .s ceadstr(n .s)
    ProcedureReturn StrF(stdead(ValF(n)))
  EndProcedure 
  
    ProcedureCDLL .s cneadstr(n .s)
    ProcedureReturn stdnead(ValF(n))
  EndProcedure 
  
  
  ProcedureCDLL .s csadstr(n .s, valeur .s)
    ProcedureReturn StrF(stdsad(ValF(n),ValF(valeur)))
  EndProcedure
  
  ProcedureCDLL .s cnsadstr(n .s)
    ProcedureReturn stdnsad(ValF(n))
    EndProcedure
  
  ProcedureCDLL .s cebstr(n .s)
    ProcedureReturn StrF(stdeb(Val (n)))
  EndProcedure
  
  ProcedureCDLL .s cnebstr(n .s)
    ProcedureReturn neb(Val(n))
  EndProcedure
  
  ProcedureCDLL .s csbstr(n .s , valeur .s)
    ProcedureReturn Str(sb(Val(n),Val(valeur)))
  EndProcedure
  
  ProcedureCDLL .s cnsbstr(n .s)
    ProcedureReturn nsb(Val(n))
  EndProcedure
  
  
  
 ;initialisation  de l'appareil ?
  ;OpenConsole()
; machaine$=ProgramFilename()
; position=FindString(machaine$,"_port")
; position2=FindString(machaine$,"_bauds")
; position3=FindString(machaine$,".")
; Port$=Mid(machaine$,position+5,position2-position-5)
; vitesse$=Mid(machaine$,position2+6,position3-position2-6)
; vitesse .i=Val(vitesse$)
 Port$=InputRequester("Choix du port de communication pour Arduino+SEN0160","disponibles : "+portdisponible(),"");
 ;vitesse .i=Val(InputRequester("Choix de la vitesse de communication","Choix : 1200,2400,4800,9600,19200","9600"));
 ;port$="Com12"
 vitesse=9600

 OpenSerialPort(0, Port$,vitesse, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 1024, 1024)
 delai=300
 t1=ElapsedMilliseconds()
;  While 1=1
;    ;PrintN(questionne_balance("C"))
;    PrintN(StrD(ead(1)))
;    Delay(200)
;  Wend
;  CloseConsole()
; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 42
; FirstLine = 33
; Folding = -----------------
; Executable = bibdyn_arduino_SEN0160.dll